window.CoolClock = function(canvasId,displayRadius,skinId,showSecondHand,gmtOffset) {

	return this.init(canvasId,displayRadius,skinId,showSecondHand,gmtOffset);

}



function changeDates() {
       	var d=new Date();
       	var weekday=new Array(7);
	var month=new Array(12);

       	weekday[0]="Sonntag";
       	weekday[1]="Montag";
       	weekday[2]="Dienstag";
       	weekday[3]="Mittwoch";
       	weekday[4]="Donnerstag";
       	weekday[5]="Freitag";
       	weekday[6]="Samstag";
       	month[0]="Januar";
       	month[1]="Februar";
       	month[2]="März";
       	month[3]="April";
       	month[4]="Mai";
       	month[5]="Juni";
       	month[6]="Juli";
	month[7]="August";
	month[8]="September";
	month[9]="Oktober";
	month[10]="November";
	month[11]="Dezember";
       	document.getElementById('d1').innerHTML = weekday[d.getDay()];
       	document.getElementById('d2').innerHTML = d.getDate() + ". " + month[d.getMonth()];
	var minutes = d.getMinutes();
	
	if(minutes < 10){
		minutes = "0" + minutes;
	}
	document.getElementById('d3').innerHTML = d.getHours() + ":" + minutes;


}



CoolClock.findAndCreateClocks = function() {

	var canvases = document.getElementsByTagName("canvas");

	for (var i=0;i<canvases.length;i++) {
    //alert(canvases[i].id.split(" ")[0].split(":"));
		var fields = canvases[i].className.split(" ")[0].split(":");


		if (fields[0] == "CoolClock") {

			new CoolClock(canvases[i].id,fields[2],fields[1],fields[3]!="noSeconds",fields[4]);
		}

	}

}



// borrowed from behaviour.js

// actually doesn't work right unless it's at the end of html document

// hence can't have a body onload

// this is a bug. FIXME

// maybe have a setTimeout hack??

CoolClock.addLoadEvent = function(func){

	var oldonload = window.onload;

	if (typeof window.onload != 'function')

		window.onload = func;

	else

		window.onload = function() {

			oldonload();

			func();

		}

}



CoolClock.config = {

	clockTracker: {},

	tickDelay: 1000,

	longTickDelay: 15000,

	defaultRadius: 160,

	renderRadius: 160,

	defaultSkin: "swissRail",

	skins:	{

		// more skins in moreskins.js

		// try making your own...



		swissRail: {

			outerBorder:	  { lineWidth: 130, radius: 1, color: "#E5ECF9", alpha: 0 },

			smallIndicator:   { lineWidth: 10, startAt: 62, endAt: 75, color: "#F4F4F4", alpha: 0 },

			largeIndicator:   { lineWidth: 10, startAt: 67, endAt: 75, color: "#F4F4F4", alpha: 0 },

			hourHand:	  { lineWidth: 8, startAt: 0, endAt: 40, color: "#F4F4F4", alpha: 1 },

			minuteHand:	  { lineWidth: 8, startAt: 0, endAt: 60, color: "#F4F4F4", alpha: 1 },

			secondHand:	  { lineWidth: 5, startAt: 68, endAt: 78, color: "red", alpha: 1 },

			secondDecoration: { lineWidth: 3, startAt: 0, radius: 4, fillColor: "#F4F4F4", color: "#F4F4F4", alpha: 1 }

		},

		chunkySwiss: {

			outerBorder: { lineWidth: 4, radius:97, color: "black", alpha: 0 },

			smallIndicator: { lineWidth: 4, startAt: 89, endAt: 93, color: "black", alpha: 0 },

			largeIndicator: { lineWidth: 8, startAt: 80, endAt: 93, color: "black", alpha: 0 },

			hourHand: { lineWidth: 12, startAt: -15, endAt: 60, color: "black", alpha: 0 },

			minuteHand: { lineWidth: 10, startAt: -15, endAt: 85, color: "black", alpha: 0 },

			secondHand: { lineWidth: 4, startAt: -20, endAt: 85, color: "red", alpha: 0 },

			secondDecoration: { lineWidth: 2, startAt: 70, radius: 8, fillColor: "red", color: "red", alpha: 0 }

		},

		chunkySwissOnBlack: {

			outerBorder: { lineWidth: 4, radius:97, color: "white", alpha: 0 },

			smallIndicator: { lineWidth: 4, startAt: 89, endAt: 93, color: "white", alpha: 0 },

			largeIndicator: { lineWidth: 8, startAt: 80, endAt: 93, color: "white", alpha: 0 },

			hourHand: { lineWidth: 12, startAt: -15, endAt: 60, color: "white", alpha: 0 },

			minuteHand: { lineWidth: 10, startAt: -15, endAt: 85, color: "white", alpha: 0 },

			secondHand: { lineWidth: 4, startAt: -20, endAt: 85, color: "red", alpha: 0 },

			secondDecoration: { lineWidth: 2, startAt: 70, radius: 8, fillColor: "red", color: "red", alpha: 0 }

		}



	}

};



CoolClock.prototype = {

	init: function(canvasId,displayRadius,skinId,showSecondHand,gmtOffset) {

		this.canvasId = canvasId;

		this.displayRadius = displayRadius || CoolClock.config.defaultRadius;

		this.skinId = skinId || CoolClock.config.defaultSkin;

		this.showSecondHand = typeof showSecondHand == "boolean" ? showSecondHand : true;

		this.tickDelay = CoolClock.config[ this.showSecondHand ? "tickDelay" : "longTickDelay"];



		this.canvas = document.getElementById(canvasId);



		this.canvas.setAttribute("width",this.displayRadius*2);

		this.canvas.setAttribute("height",this.displayRadius*2);



		this.canvas.style.width = this.displayRadius*2 + "px";

		this.canvas.style.height = this.displayRadius*2 + "px";



		this.renderRadius = CoolClock.config.renderRadius; 



		this.scale = this.displayRadius / this.renderRadius;

		this.ctx = this.canvas.getContext("2d");

		this.ctx.scale(this.scale,this.scale);



		this.gmtOffset = gmtOffset != null ? parseFloat(gmtOffset) : gmtOffset;



		CoolClock.config.clockTracker[canvasId] = this;

		this.tick();

		return this;

	},



	fullCircle: function(skin) {

		this.fullCircleAt(this.renderRadius,this.renderRadius,skin);

	},



	fullCircleAt: function(x,y,skin) {

		with (this.ctx) {

			save();

			globalAlpha = skin.alpha;

			lineWidth = skin.lineWidth;

			if (!document.all)

				beginPath();

			if (document.all)

				// excanvas doesn't scale line width so we will do it here

				lineWidth = lineWidth * this.scale;

			arc(x, y, skin.radius, 0, 2*Math.PI, false);

			if (document.all)

				// excanvas doesn't close the circle so let's color in the gap

				arc(x, y, skin.radius, -.1, 0.1, false);

			if (skin.fillColor) {

				fillStyle = skin.fillColor

				fill();

			}

			else {

				// XXX why not stroke and fill

				strokeStyle = skin.color;

				stroke();

			}

			restore();

		}

	},



	radialLineAtAngle: function(angleFraction,skin) {

		with (this.ctx) {

			save();

			translate(this.renderRadius,this.renderRadius);

			rotate(Math.PI * (2 * angleFraction - 0.5));

			globalAlpha = skin.alpha;

			strokeStyle = skin.color;

			lineWidth = skin.lineWidth;

			if (document.all)

				// excanvas doesn't scale line width so we will do it here

				lineWidth = lineWidth * this.scale;

			if (skin.radius) {

				this.fullCircleAt(skin.startAt,0,skin)

			}

			else {

				beginPath();

				moveTo(skin.startAt,0)

				lineTo(skin.endAt,0);

				stroke();

			}

			restore();

		}

	},



	render: function(hour,min,sec) {

		var skin = CoolClock.config.skins[this.skinId];

		this.ctx.clearRect(0,0,this.renderRadius*2,this.renderRadius*2);



		this.fullCircle(skin.outerBorder);



		for (var i=0;i<60;i++)

			this.radialLineAtAngle(i/60,skin[ i%5 ? "smallIndicator" : "largeIndicator"]);

				

		this.radialLineAtAngle((hour+min/60)/12,skin.hourHand);

		this.radialLineAtAngle((min+sec/60)/60,skin.minuteHand);

		if (this.showSecondHand) {

			this.radialLineAtAngle(sec/60,skin.secondHand);

			if (!document.all)

				// decoration doesn't render right in IE so lets turn it off

				this.radialLineAtAngle(sec/60,skin.secondDecoration);

		}

	},





	nextTick: function() {

		setTimeout("CoolClock.config.clockTracker['"+this.canvasId+"'].tick()",this.tickDelay);

	},



	stillHere: function() {

		return document.getElementById(this.canvasId) != null;

	},



	refreshDisplay: function() {

		changeDates();

		var now = new Date();

		if (this.gmtOffset != null) {

			// use GMT + gmtOffset

			var offsetNow = new Date(now.valueOf() + (this.gmtOffset * 1000 * 60 * 60));

			this.render(offsetNow.getUTCHours(),offsetNow.getUTCMinutes(),offsetNow.getUTCSeconds());

		}

		else {

			// use local time

			this.render(now.getHours(),now.getMinutes(),now.getSeconds());

		}

	},



	tick: function() {

		if (this.stillHere()) {

			this.refreshDisplay()

			this.nextTick();

		}

	}

}



CoolClock.addLoadEvent(CoolClock.findAndCreateClocks);

if (!window.CanvasRenderingContext2D) {



(function () {



  // alias some functions to make (compiled) code shorter

  var m = Math;

  var mr = m.round;

  var ms = m.sin;

  var mc = m.cos;



  // this is used for sub pixel precision

  var Z = 10;

  var Z2 = Z / 2;



  var G_vmlCanvasManager_ = {

    init: function (opt_doc) {

      var doc = opt_doc || document;

      if (/MSIE/.test(navigator.userAgent) && !window.opera) {

	var self = this;

	doc.attachEvent("onreadystatechange", function () {

	  self.init_(doc);

	});

      }

    },



    init_: function (doc) {

      if (doc.readyState == "complete") {

	// create xmlns

	if (!doc.namespaces["g_vml_"]) {

	  doc.namespaces.add("g_vml_", "urn:schemas-microsoft-com:vml");

	}



	// setup default css

	var ss = doc.createStyleSheet();

	ss.cssText = "canvas{display:inline-block;overflow:hidden;" +

	    // default size is 300x150 in Gecko and Opera

	    "text-align:left;width:300px;height:150px}" +

	    "g_vml_\\:*{behavior:url(#default#VML)}";



	// find all canvas elements

	var els = doc.getElementsByTagName("canvas");

	for (var i = 0; i < els.length; i++) {

	  if (!els[i].getContext) {

	    this.initElement(els[i]);

	  }

	}

      }

    },



    fixElement_: function (el) {

      // in IE before version 5.5 we would need to add HTML: to the tag name

      // but we do not care about IE before version 6

      var outerHTML = el.outerHTML;



      var newEl = el.ownerDocument.createElement(outerHTML);

      // if the tag is still open IE has created the children as siblings and

      // it has also created a tag with the name "/FOO"

      if (outerHTML.slice(-2) != "/>") {

	var tagName = "/" + el.tagName;

	var ns;

	// remove content

	while ((ns = el.nextSibling) && ns.tagName != tagName) {

	  ns.removeNode();

	}

	// remove the incorrect closing tag

	if (ns) {

	  ns.removeNode();

	}

      }

      el.parentNode.replaceChild(newEl, el);

      return newEl;

    },



    /**

     * Public initializes a canvas element so that it can be used as canvas

     * element from now on. This is called automatically before the page is

     * loaded but if you are creating elements using createElement you need to

     * make sure this is called on the element.

     * @param {HTMLElement} el The canvas element to initialize.

     * @return {HTMLElement} the element that was created.

     */

    initElement: function (el) {

      el = this.fixElement_(el);

      el.getContext = function () {

	if (this.context_) {

	  return this.context_;

	}

	return this.context_ = new CanvasRenderingContext2D_(this);

      };



      // do not use inline function because that will leak memory

      el.attachEvent('onpropertychange', onPropertyChange);

      el.attachEvent('onresize', onResize);



      var attrs = el.attributes;

      if (attrs.width && attrs.width.specified) {

	// TODO: use runtimeStyle and coordsize

	// el.getContext().setWidth_(attrs.width.nodeValue);

	el.style.width = attrs.width.nodeValue + "px";

      } else {

	el.width = el.clientWidth;

      }

      if (attrs.height && attrs.height.specified) {

	// TODO: use runtimeStyle and coordsize

	// el.getContext().setHeight_(attrs.height.nodeValue);

	el.style.height = attrs.height.nodeValue + "px";

      } else {

	el.height = el.clientHeight;

      }

      //el.getContext().setCoordsize_()

      return el;

    }

  };



  function onPropertyChange(e) {

    var el = e.srcElement;



    switch (e.propertyName) {

      case 'width':

	el.style.width = el.attributes.width.nodeValue + "px";

	el.getContext().clearRect();

	break;

      case 'height':

	el.style.height = el.attributes.height.nodeValue + "px";

	el.getContext().clearRect();

	break;

    }

  }



  function onResize(e) {

    var el = e.srcElement;

    if (el.firstChild) {

      el.firstChild.style.width =  el.clientWidth + 'px';

      el.firstChild.style.height = el.clientHeight + 'px';

    }

  }



  G_vmlCanvasManager_.init();



  // precompute "00" to "FF"

  var dec2hex = [];

  for (var i = 0; i < 16; i++) {

    for (var j = 0; j < 16; j++) {

      dec2hex[i * 16 + j] = i.toString(16) + j.toString(16);

    }

  }



  function createMatrixIdentity() {

    return [

      [1, 0, 0],

      [0, 1, 0],

      [0, 0, 1]

    ];

  }



  function matrixMultiply(m1, m2) {

    var result = createMatrixIdentity();



    for (var x = 0; x < 3; x++) {

      for (var y = 0; y < 3; y++) {

	var sum = 0;



	for (var z = 0; z < 3; z++) {

	  sum += m1[x][z] * m2[z][y];

	}



	result[x][y] = sum;

      }

    }

    return result;

  }



  function copyState(o1, o2) {

    o2.fillStyle     = o1.fillStyle;

    o2.lineCap	     = o1.lineCap;

    o2.lineJoin      = o1.lineJoin;

    o2.lineWidth     = o1.lineWidth;

    o2.miterLimit    = o1.miterLimit;

    o2.shadowBlur    = o1.shadowBlur;

    o2.shadowColor   = o1.shadowColor;

    o2.shadowOffsetX = o1.shadowOffsetX;

    o2.shadowOffsetY = o1.shadowOffsetY;

    o2.strokeStyle   = o1.strokeStyle;

    o2.arcScaleX_    = o1.arcScaleX_;

    o2.arcScaleY_    = o1.arcScaleY_;

  }



  function processStyle(styleString) {

    var str, alpha = 1;



    styleString = String(styleString);

    if (styleString.substring(0, 3) == "rgb") {

      var start = styleString.indexOf("(", 3);

      var end = styleString.indexOf(")", start + 1);

      var guts = styleString.substring(start + 1, end).split(",");



      str = "#";

      for (var i = 0; i < 3; i++) {

	str += dec2hex[Number(guts[i])];

      }



      if ((guts.length == 4) && (styleString.substr(3, 1) == "a")) {

	alpha = guts[3];

      }

    } else {

      str = styleString;

    }



    return [str, alpha];

  }



  function processLineCap(lineCap) {

    switch (lineCap) {

      case "butt":

	return "flat";

      case "round":

	return "round";

      case "square":

      default:

	return "square";

    }

  }



  /**

   * This class implements CanvasRenderingContext2D interface as described by

   * the WHATWG.

   * @param {HTMLElement} surfaceElement The element that the 2D context should

   * be associated with

   */

   function CanvasRenderingContext2D_(surfaceElement) {

    this.m_ = createMatrixIdentity();



    this.mStack_ = [];

    this.aStack_ = [];

    this.currentPath_ = [];



    // Canvas context properties

    this.strokeStyle = "#000";

    this.fillStyle = "#000";



    this.lineWidth = 1;

    this.lineJoin = "miter";

    this.lineCap = "butt";

    this.miterLimit = Z * 1;

    this.globalAlpha = 1;

    this.canvas = surfaceElement;



    var el = surfaceElement.ownerDocument.createElement('div');

    el.style.width =  surfaceElement.clientWidth + 'px';

    el.style.height = surfaceElement.clientHeight + 'px';

    el.style.overflow = 'hidden';

    el.style.position = 'absolute';

    surfaceElement.appendChild(el);



    this.element_ = el;

    this.arcScaleX_ = 1;

    this.arcScaleY_ = 1;

  };



  var contextPrototype = CanvasRenderingContext2D_.prototype;

  contextPrototype.clearRect = function() {

    this.element_.innerHTML = "";

    this.currentPath_ = [];

  };



  contextPrototype.beginPath = function() {

    // TODO: Branch current matrix so that save/restore has no effect

    //	     as per safari docs.



    this.currentPath_ = [];

  };



  contextPrototype.moveTo = function(aX, aY) {

    this.currentPath_.push({type: "moveTo", x: aX, y: aY});

    this.currentX_ = aX;

    this.currentY_ = aY;

  };



  contextPrototype.lineTo = function(aX, aY) {

    this.currentPath_.push({type: "lineTo", x: aX, y: aY});

    this.currentX_ = aX;

    this.currentY_ = aY;

  };



  contextPrototype.bezierCurveTo = function(aCP1x, aCP1y,

					    aCP2x, aCP2y,

					    aX, aY) {

    this.currentPath_.push({type: "bezierCurveTo",

			   cp1x: aCP1x,

			   cp1y: aCP1y,

			   cp2x: aCP2x,

			   cp2y: aCP2y,

			   x: aX,

			   y: aY});

    this.currentX_ = aX;

    this.currentY_ = aY;

  };



  contextPrototype.quadraticCurveTo = function(aCPx, aCPy, aX, aY) {

    // the following is lifted almost directly from

    // http://developer.mozilla.org/en/docs/Canvas_tutorial:Drawing_shapes

    var cp1x = this.currentX_ + 2.0 / 3.0 * (aCPx - this.currentX_);

    var cp1y = this.currentY_ + 2.0 / 3.0 * (aCPy - this.currentY_);

    var cp2x = cp1x + (aX - this.currentX_) / 3.0;

    var cp2y = cp1y + (aY - this.currentY_) / 3.0;

    this.bezierCurveTo(cp1x, cp1y, cp2x, cp2y, aX, aY);

  };



  contextPrototype.arc = function(aX, aY, aRadius,

				  aStartAngle, aEndAngle, aClockwise) {

    aRadius *= Z;

    var arcType = aClockwise ? "at" : "wa";



    var xStart = aX + (mc(aStartAngle) * aRadius) - Z2;

    var yStart = aY + (ms(aStartAngle) * aRadius) - Z2;



    var xEnd = aX + (mc(aEndAngle) * aRadius) - Z2;

    var yEnd = aY + (ms(aEndAngle) * aRadius) - Z2;



    // IE won't render arches drawn counter clockwise if xStart == xEnd.

    if (xStart == xEnd && !aClockwise) {

      xStart += 0.125; // Offset xStart by 1/80 of a pixel. Use something

		       // that can be represented in binary

    }



    this.currentPath_.push({type: arcType,

			   x: aX,

			   y: aY,

			   radius: aRadius,

			   xStart: xStart,

			   yStart: yStart,

			   xEnd: xEnd,

			   yEnd: yEnd});



  };



  contextPrototype.rect = function(aX, aY, aWidth, aHeight) {

    this.moveTo(aX, aY);

    this.lineTo(aX + aWidth, aY);

    this.lineTo(aX + aWidth, aY + aHeight);

    this.lineTo(aX, aY + aHeight);

    this.closePath();

  };



  contextPrototype.strokeRect = function(aX, aY, aWidth, aHeight) {

    // Will destroy any existing path (same as FF behaviour)

    this.beginPath();

    this.moveTo(aX, aY);

    this.lineTo(aX + aWidth, aY);

    this.lineTo(aX + aWidth, aY + aHeight);

    this.lineTo(aX, aY + aHeight);

    this.closePath();

    this.stroke();

  };



  contextPrototype.fillRect = function(aX, aY, aWidth, aHeight) {

    // Will destroy any existing path (same as FF behaviour)

    this.beginPath();

    this.moveTo(aX, aY);

    this.lineTo(aX + aWidth, aY);

    this.lineTo(aX + aWidth, aY + aHeight);

    this.lineTo(aX, aY + aHeight);

    this.closePath();

    this.fill();

  };



  contextPrototype.createLinearGradient = function(aX0, aY0, aX1, aY1) {

    var gradient = new CanvasGradient_("gradient");

    return gradient;

  };



  contextPrototype.createRadialGradient = function(aX0, aY0,

						   aR0, aX1,

						   aY1, aR1) {

    var gradient = new CanvasGradient_("gradientradial");

    gradient.radius1_ = aR0;

    gradient.radius2_ = aR1;

    gradient.focus_.x = aX0;

    gradient.focus_.y = aY0;

    return gradient;

  };



  contextPrototype.drawImage = function (image, var_args) {

    var dx, dy, dw, dh, sx, sy, sw, sh;



    // to find the original width we overide the width and height

    var oldRuntimeWidth = image.runtimeStyle.width;

    var oldRuntimeHeight = image.runtimeStyle.height;

    image.runtimeStyle.width = 'auto';

    image.runtimeStyle.height = 'auto';



    // get the original size

    var w = image.width;

    var h = image.height;



    // and remove overides

    image.runtimeStyle.width = oldRuntimeWidth;

    image.runtimeStyle.height = oldRuntimeHeight;



    if (arguments.length == 3) {

      dx = arguments[1];

      dy = arguments[2];

      sx = sy = 0;

      sw = dw = w;

      sh = dh = h;

    } else if (arguments.length == 5) {

      dx = arguments[1];

      dy = arguments[2];

      dw = arguments[3];

      dh = arguments[4];

      sx = sy = 0;

      sw = w;

      sh = h;

    } else if (arguments.length == 9) {

      sx = arguments[1];

      sy = arguments[2];

      sw = arguments[3];

      sh = arguments[4];

      dx = arguments[5];

      dy = arguments[6];

      dw = arguments[7];

      dh = arguments[8];

    } else {

      throw "Invalid number of arguments";

    }



    var d = this.getCoords_(dx, dy);



    var w2 = sw / 2;

    var h2 = sh / 2;



    var vmlStr = [];



    var W = 10;

    var H = 10;



    // For some reason that I've now forgotten, using divs didn't work

    vmlStr.push(' <g_vml_:group',

		' coordsize="', Z * W, ',', Z * H, '"',

		' coordorigin="0,0"' ,

		' style="width:', W, ';height:', H, ';position:absolute;');



    // If filters are necessary (rotation exists), create them

    // filters are bog-slow, so only create them if abbsolutely necessary

    // The following check doesn't account for skews (which don't exist

    // in the canvas spec (yet) anyway.



    if (this.m_[0][0] != 1 || this.m_[0][1]) {

      var filter = [];



      // Note the 12/21 reversal

      filter.push("M11='", this.m_[0][0], "',",

		  "M12='", this.m_[1][0], "',",

		  "M21='", this.m_[0][1], "',",

		  "M22='", this.m_[1][1], "',",

		  "Dx='", mr(d.x / Z), "',",

		  "Dy='", mr(d.y / Z), "'");



      // Bounding box calculation (need to minimize displayed area so that

      // filters don't waste time on unused pixels.

      var max = d;

      var c2 = this.getCoords_(dx + dw, dy);

      var c3 = this.getCoords_(dx, dy + dh);

      var c4 = this.getCoords_(dx + dw, dy + dh);



      max.x = Math.max(max.x, c2.x, c3.x, c4.x);

      max.y = Math.max(max.y, c2.y, c3.y, c4.y);



      vmlStr.push("padding:0 ", mr(max.x / Z), "px ", mr(max.y / Z),

		  "px 0;filter:progid:DXImageTransform.Microsoft.Matrix(",

		  filter.join(""), ", sizingmethod='clip');")

    } else {

      vmlStr.push("top:", mr(d.y / Z), "px;left:", mr(d.x / Z), "px;")

    }



    vmlStr.push(' ">' ,

		'<g_vml_:image src="', image.src, '"',

		' style="width:', Z * dw, ';',

		' height:', Z * dh, ';"',

		' cropleft="', sx / w, '"',

		' croptop="', sy / h, '"',

		' cropright="', (w - sx - sw) / w, '"',

		' cropbottom="', (h - sy - sh) / h, '"',

		' />',

		'</g_vml_:group>');



    this.element_.insertAdjacentHTML("BeforeEnd",

				    vmlStr.join(""));

  };



  contextPrototype.stroke = function(aFill) {

    var lineStr = [];

    var lineOpen = false;

    var a = processStyle(aFill ? this.fillStyle : this.strokeStyle);

    var color = a[0];

    var opacity = a[1] * this.globalAlpha;



    var W = 10;

    var H = 10;



    lineStr.push('<g_vml_:shape',

		 ' fillcolor="', color, '"',

		 ' filled="', Boolean(aFill), '"',

		 ' style="position:absolute;width:', W, ';height:', H, ';"',

		 ' coordorigin="0 0" coordsize="', Z * W, ' ', Z * H, '"',

		 ' stroked="', !aFill, '"',

		 ' strokeweight="', this.lineWidth, '"',

		 ' strokecolor="', color, '"',

		 ' path="');



    var newSeq = false;

    var min = {x: null, y: null};

    var max = {x: null, y: null};



    for (var i = 0; i < this.currentPath_.length; i++) {

      var p = this.currentPath_[i];



      if (p.type == "moveTo") {

	lineStr.push(" m ");

	var c = this.getCoords_(p.x, p.y);

	lineStr.push(mr(c.x), ",", mr(c.y));

      } else if (p.type == "lineTo") {

	lineStr.push(" l ");

	var c = this.getCoords_(p.x, p.y);

	lineStr.push(mr(c.x), ",", mr(c.y));

      } else if (p.type == "close") {

	lineStr.push(" x ");

      } else if (p.type == "bezierCurveTo") {

	lineStr.push(" c ");

	var c = this.getCoords_(p.x, p.y);

	var c1 = this.getCoords_(p.cp1x, p.cp1y);

	var c2 = this.getCoords_(p.cp2x, p.cp2y);

	lineStr.push(mr(c1.x), ",", mr(c1.y), ",",

		     mr(c2.x), ",", mr(c2.y), ",",

		     mr(c.x), ",", mr(c.y));

      } else if (p.type == "at" || p.type == "wa") {

	lineStr.push(" ", p.type, " ");

	var c  = this.getCoords_(p.x, p.y);

	var cStart = this.getCoords_(p.xStart, p.yStart);

	var cEnd = this.getCoords_(p.xEnd, p.yEnd);



	lineStr.push(mr(c.x - this.arcScaleX_ * p.radius), ",",

		     mr(c.y - this.arcScaleY_ * p.radius), " ",

		     mr(c.x + this.arcScaleX_ * p.radius), ",",

		     mr(c.y + this.arcScaleY_ * p.radius), " ",

		     mr(cStart.x), ",", mr(cStart.y), " ",

		     mr(cEnd.x), ",", mr(cEnd.y));

      }





      // TODO: Following is broken for curves due to

      //       move to proper paths.



      // Figure out dimensions so we can do gradient fills

      // properly

      if(c) {

	if (min.x == null || c.x < min.x) {

	  min.x = c.x;

	}

	if (max.x == null || c.x > max.x) {

	  max.x = c.x;

	}

	if (min.y == null || c.y < min.y) {

	  min.y = c.y;

	}

	if (max.y == null || c.y > max.y) {

	  max.y = c.y;

	}

      }

    }

    lineStr.push(' ">');



    if (typeof this.fillStyle == "object") {

      var focus = {x: "50%", y: "50%"};

      var width = (max.x - min.x);

      var height = (max.y - min.y);

      var dimension = (width > height) ? width : height;



      focus.x = mr((this.fillStyle.focus_.x / width) * 100 + 50) + "%";

      focus.y = mr((this.fillStyle.focus_.y / height) * 100 + 50) + "%";



      var colors = [];



      // inside radius (%)

      if (this.fillStyle.type_ == "gradientradial") {

	var inside = (this.fillStyle.radius1_ / dimension * 100);



	// percentage that outside radius exceeds inside radius

	var expansion = (this.fillStyle.radius2_ / dimension * 100) - inside;

      } else {

	var inside = 0;

	var expansion = 100;

      }



      var insidecolor = {offset: null, color: null};

      var outsidecolor = {offset: null, color: null};



      // We need to sort 'colors' by percentage, from 0 > 100 otherwise ie

      // won't interpret it correctly

      this.fillStyle.colors_.sort(function (cs1, cs2) {

	return cs1.offset - cs2.offset;

      });



      for (var i = 0; i < this.fillStyle.colors_.length; i++) {

	var fs = this.fillStyle.colors_[i];



	colors.push( (fs.offset * expansion) + inside, "% ", fs.color, ",");



	if (fs.offset > insidecolor.offset || insidecolor.offset == null) {

	  insidecolor.offset = fs.offset;

	  insidecolor.color = fs.color;

	}



	if (fs.offset < outsidecolor.offset || outsidecolor.offset == null) {

	  outsidecolor.offset = fs.offset;

	  outsidecolor.color = fs.color;

	}

      }

      colors.pop();



      lineStr.push('<g_vml_:fill',

		   ' color="', outsidecolor.color, '"',

		   ' color2="', insidecolor.color, '"',

		   ' type="', this.fillStyle.type_, '"',

		   ' focusposition="', focus.x, ', ', focus.y, '"',

		   ' colors="', colors.join(""), '"',

		   ' opacity="', opacity, '" />');

    } else if (aFill) {

      lineStr.push('<g_vml_:fill color="', color, '" opacity="', opacity, '" />');

    } else {

      lineStr.push(

	'<g_vml_:stroke',

	' opacity="', opacity,'"',

	' joinstyle="', this.lineJoin, '"',

	' miterlimit="', this.miterLimit, '"',

	' endcap="', processLineCap(this.lineCap) ,'"',

	' weight="', this.lineWidth, 'px"',

	' color="', color,'" />'

      );

    }



    lineStr.push("</g_vml_:shape>");



    this.element_.insertAdjacentHTML("beforeEnd", lineStr.join(""));



    this.currentPath_ = [];

  };



  contextPrototype.fill = function() {

    this.stroke(true);

  }



  contextPrototype.closePath = function() {

    this.currentPath_.push({type: "close"});

  };



  /**

   * @private

   */

  contextPrototype.getCoords_ = function(aX, aY) {

    return {

      x: Z * (aX * this.m_[0][0] + aY * this.m_[1][0] + this.m_[2][0]) - Z2,

      y: Z * (aX * this.m_[0][1] + aY * this.m_[1][1] + this.m_[2][1]) - Z2

    }

  };



  contextPrototype.save = function() {

    var o = {};

    copyState(this, o);

    this.aStack_.push(o);

    this.mStack_.push(this.m_);

    this.m_ = matrixMultiply(createMatrixIdentity(), this.m_);

  };



  contextPrototype.restore = function() {

    copyState(this.aStack_.pop(), this);

    this.m_ = this.mStack_.pop();

  };



  contextPrototype.translate = function(aX, aY) {

    var m1 = [

      [1,  0,  0],

      [0,  1,  0],

      [aX, aY, 1]

    ];



    this.m_ = matrixMultiply(m1, this.m_);



  };



  contextPrototype.rotate = function(aRot) {

    var c = mc(aRot);

    var s = ms(aRot);



    var m1 = [

      [c,  s, 0],

      [-s, c, 0],

      [0,  0, 1]

    ];



    this.m_ = matrixMultiply(m1, this.m_);

  };



  contextPrototype.scale = function(aX, aY) {

    this.arcScaleX_ *= aX;

    this.arcScaleY_ *= aY;

    var m1 = [

      [aX, 0,  0],

      [0,  aY, 0],

      [0,  0,  1]

    ];



    this.m_ = matrixMultiply(m1, this.m_);

  };



  /******** STUBS ********/

  contextPrototype.clip = function() {

    // TODO: Implement

  };



  contextPrototype.arcTo = function() {

    // TODO: Implement

  };



  contextPrototype.createPattern = function() {

    return new CanvasPattern_;

  };



  // Gradient / Pattern Stubs

  function CanvasGradient_(aType) {

    this.type_ = aType;

    this.radius1_ = 0;

    this.radius2_ = 0;

    this.colors_ = [];

    this.focus_ = {x: 0, y: 0};

  }



  CanvasGradient_.prototype.addColorStop = function(aOffset, aColor) {

    aColor = processStyle(aColor);

    this.colors_.push({offset: 1-aOffset, color: aColor});

  };



  function CanvasPattern_() {}



  // set up externs

  G_vmlCanvasManager = G_vmlCanvasManager_;

  CanvasRenderingContext2D = CanvasRenderingContext2D_;

  CanvasGradient = CanvasGradient_;

  CanvasPattern = CanvasPattern_;



})();



} // if